=== debian/changelog ===
libpmemobj-cpp (1.5.1-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 19 Feb 2019 18:16:55 +0100

libpmemobj-cpp (1.5.1~rc4-1) experimental; urgency=medium

  * New upstream pre-release.
  * Enable the map_cli autopkgtest.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 15 Feb 2019 16:30:48 +0100

libpmemobj-cpp (1.5-3) unstable; urgency=medium

  * Make autopkgtests work on minimal chroots.
  * Add a clang test.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 09 Feb 2019 21:50:19 +0100

libpmemobj-cpp (1.5-2) unstable; urgency=medium

  * Make the -dev package depend on libpmemobj-dev.
  * Use examples as autopkgtests (compiling all, running some).
  * Build-Depend on libunwind-dev rather than libunwind8-dev.
  * Delete include/libpmemobj++/version.hpp on clean.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 03 Feb 2019 22:24:18 +0100

libpmemobj-cpp (1.5-1) unstable; urgency=medium

  * Initial release (Closes: #920036)

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 30 Jan 2019 20:28:25 +0100
