=== debian/tests/control ===
Tests: array-pc
Depends: g++, make, cmake, libpmemobj-cpp-dev, pkg-config

Tests: array-clang
Depends: clang, make, cmake, libpmemobj-cpp-dev, pkg-config

Tests: pmpong
Depends: g++, make, cmake, libpmemobj-cpp-dev, libsfml-dev

Tests: panaconda pman
Depends: g++, make, cmake, libpmemobj-cpp-dev, libncurses-dev

Tests: map-cli
Depends: g++, make, cmake, libpmemobj-cpp-dev

Tests: array queue
Depends: g++, make, cmake, libpmemobj-cpp-dev
