## libpmemobj-cpp 1.6

=== debian/changelog ===
libpmemobj-cpp (1.6-1) experimental; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 18 Mar 2019 14:19:18 +0100
