=== debian/control ===
--- 
+++ 
@@ -9,7 +9,8 @@
                libpmemobj-dev (>= 1.5~),
                libsfml-dev,
                libunwind-dev,
-               pkg-config
+               pkg-config,
+               valgrind
 Standards-Version: 4.3.0
 Section: libs
 Homepage: https://pmem.io/pmdk/cpp_obj/
@@ -20,7 +21,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}, libpmemobj-dev
+Depends: libpmemobj-dev, ${misc:Depends}, ${shlibs:Depends}
 Description: C++ bindings to libpmemobj
  The C++ bindings provide an easier to use (and thus less error prone
  version) of libpmemobj -- the persistent memory object store -- through
